from fractions import Fraction
from __calcularR import calcularR
from __cantcomps import cantcomps
from __encontrar_N_zeta import encontrar_N_zeta
from __minimo import minimo


def calcularcosto (N, largo, z, R):
	costo_crearfirmas = z * largo
	costo_firmar = N
	costo_encontrarcomp = Fraction (cantcomps (N, largo), R)
	costo = costo_crearfirmas + costo_firmar + costo_encontrarcomp
	return costo


def crear_evaluar (largo, bits):

	def evaluar (zeta):
		z1, z2 = zeta, zeta + 1

		N1, R1 = encontrar_N_zeta (largo, z1, bits, devolverR=True, mostrar=False)
		if N1 == None: return False

		N2, R2 = encontrar_N_zeta (largo, z2, bits, devolverR=True, mostrar=False)

		costo1 = calcularcosto (N1, largo, z1, R1)
		costo2 = calcularcosto (N2, largo, z2, R2)

		valido = (costo2 > costo1)
		return valido

	return evaluar


def encontrar_zeta1Sig (largo, bits, mostrar=False):
	evaluar = crear_evaluar (largo, bits)
	zeta = minimo (evaluar, mostrar)
	return zeta


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 128
	largo = 64

	zeta = encontrar_zeta1Sig (largo, bits, mostrar=True)

	print ('bits, largo = ' + str ((bits, largo)))
	print ('zeta = ' + str (zeta))

